package com.dlsm.service.impl;

import com.dlsm.model.Bus3;
import com.dlsm.service.Bus3Service;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.RowMapper;
import org.springframework.stereotype.Service;

import java.util.ArrayList;
import java.util.List;

/**
 * 客运公交controller
 * @author xxg
 * @date 2023-02-03
 */

@Service
public class Bus3ServiceImpl implements Bus3Service {

    @Autowired
    private JdbcTemplate jdbcTemplate;

    @Override
    public List<Bus3> selectBus3List(com.dlsm.model.Bus3 bus) {
        String sql = "   SELECT ID, TIME, ROUTEID,\n" +
                "        ROUTENAME, SELLSTATIONID, SELLSTATIONNAME,\n" +
                "        ENDSTATIONID, ENDSTATIONNAME, DESSTATIONID, DESSTATIONNAME,\n" +
                "        CITYCODE, CANSELL, TYPEID, TYPENAME,\n" +
                "        CHECKGATE, GUIDEPRICE, FULLPRICE, HALFPRICE,\n" +
                "        SEATREMAIN, BEDFULLPRICE, BEDHALFPRICE, BEDREMAIN,\n" +
                "        ADDITIONALFULLPRICE, ADDITIONALHALFPRICE, ADDITIONALREMAIN, KIND,\n" +
                "        TOTALSEAT, VEHICLEMODEL, TAKECHILDRENQUANTIT,\n" +
                "        ADDSTATUS, UNITID, BUSSTATUS, CANCHILDRENQUANTITY,\n" +
                "        CANHALFQUANTITY, TOTALCOUNT, RUNTIME, LICENSETAGNO,\n" +
                "        FASTNOTE, STATIONALIAS, OUT_ID, CREATE_TIME FROM OUT_BUS3";
        RowMapper<Bus3> bus3list = new BeanPropertyRowMapper<Bus3>(Bus3.class);
        List<Bus3> list = new ArrayList<Bus3>();
        list = jdbcTemplate.query(sql.toString(), bus3list);
        return list;
    }

    @Override
    public int insertBus3(Bus3 bus) {

        if(bus==null)
        {
            return 0;
        }

        String sql = "insert into OUT_BUS3(OUT_ID ,CREATE_TIME,Time ,RouteID ,RouteName ," +
                "SellStationID ,SellStationName ,EndStationID ,EndStationName ,DesStationID," +
                "DesStationName,CityCode, CanSell ,TypeID ,TypeName ,CheckGate ,GuidePrice ," +
                "FullPrice ,HalfPrice ,SeatRemain ,BedFullPrice ,BedHalfPrice ,BedRemain ," +
                "AdditionalFullPrice ,AdditionalHalfPrice ,AdditionalRemain ,Kind ,TotalSeat ," +
                "VehicleModel ,TakeChildrenQuantit ,AddStatus ,UnitID ,BusStatus ," +
                "CanChildrenQuantity ,CanHalfQuantity ,TotalCount ,RunTime ,LicenseTagNo ," +
                "FastNote ,StationAlias) values ('"+bus.getOutId()+"', '"+bus.getCreateTime()+"', " +
                "'"+bus.getTime()+"', '"+bus.getRouteID()+"', '"+bus.getRouteName()+"', " +
                "'"+bus.getSellStationID()+"', " +
                "'"+bus.getSellStationName()+"', '"+bus.getEndStationID()+"', " +
                "'"+bus.getEndStationName()+"','"+bus.getDesStationID()+"'," +
                "'"+bus.getDesStationName()+"','"+bus.getCityCode()+"', " +
                "'"+bus.getCanSell()+"', '"+bus.getTypeID()+"', " +
                "'"+bus.getTypeName()+"', '"+bus.getCheckGate()+"', " +
                "'"+bus.getGuidePrice()+"', '"+bus.getFullPrice()+"', " +
                "'"+bus.getHalfPrice()+"', '"+bus.getSeatRemain()+"', " +
                "'"+bus.getBedFullPrice()+"', '"+bus.getBedHalfPrice()+"', " +
                "'"+bus.getBedRemain()+"', '"+bus.getAdditionalFullPrice()+"', " +
                "'"+bus.getAdditionalHalfPrice()+"', '"+bus.getAdditionalRemain()+"', " +
                "'"+bus.getKind()+"', '"+bus.getTotalSeat()+"', " +
                "'"+bus.getVehicleModel()+"', '"+bus.getTakeChildrenQuantit()+"', " +
                "'"+bus.getAddStatus()+"', '"+bus.getUnitID()+"', " +
                "'"+bus.getBusStatus()+"', '"+bus.getCanChildrenQuantity()+"', " +
                "'"+bus.getCanHalfQuantity()+"', '"+bus.getTotalCount()+"', " +
                "'"+bus.getRunTime()+"','"+bus.getLicenseTagNo()+"', " +
                "'"+bus.getFastNote()+"', '"+bus.getStationAlias()+"')";

        System.out.println("OUT_BUS3="+sql);

        return jdbcTemplate.update(sql);

    }
}
