package com.dlsm.task;

import com.dlsm.webapi.GetBus3;
import com.dlsm.webapi.base.Mission;

import java.time.LocalDate;
import java.util.Iterator;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.FutureTask;

public class ScheduleTask implements Callable<Mission> {
    private boolean flag = true;
    private List<? extends Mission> missionList;

    public ScheduleTask() {
    }

    public void init(List<? extends Mission> taskInfoList) {
        this.missionList = taskInfoList;
    }

    public void manageTask() {
        LocalDate now = LocalDate.now();
        String year = String.valueOf(now.getYear());
        String monthValue = String.valueOf(now.getMonthValue());
        String dayOfMonth = String.valueOf(now.getDayOfMonth());
        String dateString = year + "-" + monthValue + "-" + dayOfMonth;
        Iterator var7 = this.missionList.iterator();

        while(var7.hasNext()) {
            Mission mission = (Mission)var7.next();
            TransportTask transportTask = new TransportTask();
            if (mission instanceof GetBus3) {
                ((GetBus3)mission).setBusDate(dateString);
            }

            transportTask.init(mission);
            FutureTask<Mission> futureTask = new FutureTask(transportTask);
            MainScheduleManager.EXECUTOR.submit(futureTask);

            try {
                mission = (Mission)futureTask.get();
            } catch (InterruptedException var11) {
                var11.printStackTrace();
            } catch (ExecutionException var12) {
                var12.printStackTrace();
            }
        }

    }

    private boolean condition() {
        return false;
    }

    public boolean start() {
        return this.flag = true;
    }

    public boolean stop() {
        return this.flag = false;
    }

    public Mission call() throws Exception {
        while(true) {
            this.manageTask();
            Thread.sleep(300000L);
            System.out.println("监测线程正在执行");
        }
    }
}