package com.dlsm.task;

import java.util.Map;
import java.util.concurrent.Callable;

import com.dlsm.transport.Trans;
import com.dlsm.transport.impl.WebApiTransport;
import com.dlsm.webapi.base.Mission;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.util.StopWatch;

public class TransportTask implements Callable<Mission> {
    Logger logger = LoggerFactory.getLogger(TransportTask.class);
    private String name;
    Trans trans;
    Mission mission;

    public TransportTask() {
    }

    public void init(Mission mission) {
        this.mission = mission;
    }

    public Mission call() throws Exception {
        StopWatch stopWatch = new StopWatch(this.name);
        stopWatch.start();
        this.trans = new WebApiTransport(this.mission);
        Map<String, Object> message = this.trans.templateMethod();
        stopWatch.stop();
        return this.mission;
    }
}
