package com.dlsm.transport.impl;
import java.io.BufferedReader;
import java.io.ByteArrayInputStream;
import java.io.InputStream;
import java.io.InputStreamReader;
import java.net.URL;
import java.net.URLConnection;
import java.time.LocalDateTime;
import java.util.HashMap;
import java.util.Map;

import com.dlsm.transport.Trans;
import com.dlsm.webapi.base.Mission;
import org.dom4j.Document;
import org.dom4j.io.SAXReader;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;

public class WebApiTransport implements Trans {
    private static Logger logger = LoggerFactory.getLogger(WebApiTransport.class);
    private Mission mission;

    public WebApiTransport(Mission mission) {
        this.mission = mission;
    }

    public Map<String, Object> templateMethod() {
        Object map = new HashMap();

        try {
            String urlStr = this.mission.getGetUrl();
            logger.info("请求时间:" + LocalDateTime.now() + "\n请求地址:" + urlStr);
            InputStream is = this.getResponseMessage(urlStr);
            StringBuilder sb = new StringBuilder();
            BufferedReader br = new BufferedReader(new InputStreamReader(is, "UTF-8"));

            String line;
            while((line = br.readLine()) != null) {
                sb.append(line);
            }

            String tempXmlStr = sb.toString();
            tempXmlStr = tempXmlStr.replaceAll("_&", "");
            tempXmlStr = tempXmlStr.replaceAll("&quot;", "\"");
            tempXmlStr = tempXmlStr.replaceAll("&amp;", "&");
            tempXmlStr = tempXmlStr.replaceAll("&lt;", "<");
            tempXmlStr = tempXmlStr.replaceAll("&gt;", ">");
            tempXmlStr = tempXmlStr.replace("<?xml version=\"1.0\" encoding=\"utf-8\"?><string xmlns=\"http://www.zjeasy.com/\">", "");
            tempXmlStr = tempXmlStr.replace("</string>", "");
            SAXReader reader = new SAXReader();
            Document document = reader.read(new ByteArrayInputStream(tempXmlStr.getBytes("utf-8")));
            map = this.mission.parseAndSave(document);
        } catch (Exception var10) {
            var10.printStackTrace();
        }

        return (Map)map;
    }

    private InputStream getResponseMessage(String urlStr) throws Exception {
        URL url = new URL(urlStr);
        URLConnection conn = url.openConnection();
        conn.setUseCaches(false);
        conn.setDoInput(true);
        conn.setDoOutput(true);
        InputStream is = conn.getInputStream();
        return is;
    }
}
