package com.dlsm.webapi;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;

import com.dlsm.SpringbootsApplication;
import com.dlsm.mapper.SellStationsMapper;
import com.dlsm.model.Bus3;
import com.dlsm.model.SellStations;
import com.dlsm.service.impl.Bus3ServiceImpl;
import com.dlsm.service.impl.EndStation2ServiceImpl;
import com.dlsm.service.impl.SellStationsServiceImpl;
import com.dlsm.webapi.base.Mission;
import org.dom4j.Document;
import org.dom4j.Element;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.util.DigestUtils;

/**
 * 客运公交数据采集保存
 * @author xxg
 * @date 2023-02-03
 */

public class GetSellStations extends Mission {
    Logger logger = LoggerFactory.getLogger(GetEndStations2.class);
    private String url;
    private final String PATH = "/st6_ticket_hsga/sell/GetSellStations?";
    private String partnerID;
    private String signType;
    private String signData;
    private String unitID;
    private String md5;



    public String getSignData() {
        this.signData = "unitID=" + this.getUnitID() + this.getMd5();
        this.signData = DigestUtils.md5DigestAsHex(this.signData.getBytes());
        return this.signData;
    }

    public String getGetSellStationsMessage() {
        return "partnerID=" + this.getPartnerID() + "&signType=&signData=" + this.getSignData() + "&unitID=" + this.getUnitID() + "&ran=";
    }

    public String getGetUrl() {
        String url = this.url + "/st6_ticket_hsga/sell/GetSellStations?" + this.getGetSellStationsMessage();
        return url;
    }

    public GetSellStations(String url, String partnerId, String unitID, String md5) {
        this.url = url;
        this.partnerID = partnerId;
        this.unitID = unitID;
        this.md5 = md5;
    }

    public Map<String, Object> parseAndSave(Document doc) {
        Map<String, Object> map = new HashMap();
        List<SellStations> sellStationsList = new ArrayList();
        Element root = doc.getRootElement();
        Iterator it = root.elementIterator("body");

        label36:
        while(it.hasNext()) {
            Element element = (Element)it.next();
            Iterator itEndStation2 = element.elementIterator("SellStation");

            while(true) {
                Element endStation2Element;
                do {
                    if (!itEndStation2.hasNext()) {
                        continue label36;
                    }

                    endStation2Element = (Element)itEndStation2.next();
                    System.out.println(endStation2Element.elementText("Name"));
                } while(!"南站配客".equals(endStation2Element.elementText("Name")) && !"中心站".equals(endStation2Element.elementText("Name")));

                SellStations sellStations = new SellStations();
                sellStations.setCreateTime(new Date());
                sellStations.setOutId(endStation2Element.elementText("ID"));
                sellStations.setName(endStation2Element.elementText("Name"));
                if ("南站配客".equals(endStation2Element.elementText("Name"))) {
                    sellStations.setKey("nzpk");
                } else if ("中心站".equals(endStation2Element.elementText("Name"))) {
                    sellStations.setKey("zxz");
                }

                sellStations.setUnitID(endStation2Element.elementText("UnitID"));
                sellStations.setUnitName(endStation2Element.elementText("UnitName"));
                sellStations.setCityCode(endStation2Element.elementText("CityCode"));
                sellStations.setCityName(endStation2Element.elementText("CityName"));
                sellStations.setStationID(endStation2Element.elementText("StationID"));
                sellStations.setCityCode(endStation2Element.elementText("StationName"));
                sellStations.setCityName(endStation2Element.elementText("SaleEnabled"));
                sellStations.setPresellBeginDate(endStation2Element.elementText("PresellBeginDate"));
                sellStations.setPresellEndDate(endStation2Element.elementText("PresellEndDate"));
                sellStations.setCheckTicketEnabled(endStation2Element.elementText("CheckTicketEnabled"));
                sellStations.setCheckTicketNote(endStation2Element.elementText("CheckTicketNote"));
                this.logger.info(sellStations.toString());
                sellStationsList.add(sellStations);
                map.put(sellStations.getKey(), sellStations);
            }
        }

        if (sellStationsList.size() > 0) {
            this.save(sellStationsList);
        }

        return map;
    }



    private boolean save(List<SellStations> sellStationsList) {

        SellStationsMapper sellStationsMapper = (SellStationsMapper) SpringbootsApplication.appctx.getBean(SellStationsMapper.class);
        Iterator var4 = sellStationsList.iterator();

        while(var4.hasNext()) {
            SellStations station = (SellStations)var4.next();
            sellStationsMapper.insertSellStations(station);
        }

        return false;

    }

    public Logger getLogger() {
        return this.logger;
    }

    public String getUrl() {
        return this.url;
    }

    public String getPATH() {
        return "/st6_ticket_hsga/sell/GetSellStations?";
    }

    public String getPartnerID() {
        return this.partnerID;
    }

    public String getSignType() {
        return this.signType;
    }

    public String getUnitID() {
        return this.unitID;
    }

    public String getMd5() {
        return this.md5;
    }

    public void setLogger(Logger logger) {
        this.logger = logger;
    }

    public void setUrl(String url) {
        this.url = url;
    }

    public void setPartnerID(String partnerID) {
        this.partnerID = partnerID;
    }

    public void setSignType(String signType) {
        this.signType = signType;
    }

    public void setSignData(String signData) {
        this.signData = signData;
    }

    public void setUnitID(String unitID) {
        this.unitID = unitID;
    }

    public void setMd5(String md5) {
        this.md5 = md5;
    }

    public String toString() {
        return "GetSellStations(logger=" + this.getLogger() + ", url=" + this.getUrl() + ", PATH=" + this.getPATH() + ", partnerID=" + this.getPartnerID() + ", signType=" + this.getSignType() + ", signData=" + this.getSignData() + ", unitID=" + this.getUnitID() + ", md5=" + this.getMd5() + ")";
    }

    protected boolean canEqual(Object other) {
        return other instanceof GetSellStations;
    }

}

